Index: simplerunner/pom.xml
===================================================================
--- simplerunner/pom.xml	(revision 8)
+++ simplerunner/pom.xml	(revision 9)
@@ -6,5 +6,5 @@
 	<groupId>geniusweb</groupId>
 	<artifactId>simplerunner</artifactId>
-	<version>1.0.0</version>
+	<version>1.1.0</version>
 	<packaging>jar</packaging>
 
@@ -16,5 +16,5 @@
 		<basedir>.</basedir>
 		<passwd>${env.ARTIFACTORY_PASS}</passwd>
-		<jackson-2-version>2.9.6</jackson-2-version>
+		<jackson-2-version>2.9.10</jackson-2-version>
 	</properties>
 
@@ -31,15 +31,16 @@
 			<groupId>geniusweb</groupId>
 			<artifactId>protocol</artifactId>
-			<version>1.0.0</version>
+			<version>1.1.0</version>
 		</dependency>
 		<dependency>
 			<groupId>geniusweb</groupId>
 			<artifactId>party</artifactId>
-			<version>1.0.0</version>
+			<version>1.1.0</version>
 		</dependency>
 		<dependency>
 			<groupId>geniusweb.exampleparties</groupId>
 			<artifactId>randomparty</artifactId>
-			<version>1.0.0</version>
+			<version>1.1.0</version>
+			<scope>test</scope>
 		</dependency>
 
@@ -98,5 +99,22 @@
 				</configuration>
 			</plugin>
-
+			<plugin>
+				<groupId>org.apache.maven.plugins</groupId>
+				<artifactId>maven-enforcer-plugin</artifactId>
+				<version>3.0.0-M2</version>
+				<executions>
+					<execution>
+						<id>enforce</id>
+						<configuration>
+							<rules>
+								<dependencyConvergence />
+							</rules>
+						</configuration>
+						<goals>
+							<goal>enforce</goal>
+						</goals>
+					</execution>
+				</executions>
+			</plugin>
 			<plugin>
 				<groupId>org.apache.maven.plugins</groupId>
Index: simplerunner/src/main/java/geniusweb/simplerunner/BasicConnection.java
===================================================================
--- simplerunner/src/main/java/geniusweb/simplerunner/BasicConnection.java	(revision 8)
+++ simplerunner/src/main/java/geniusweb/simplerunner/BasicConnection.java	(revision 9)
@@ -4,5 +4,5 @@
 import java.net.URI;
 
-import geniusweb.connection.Connection;
+import geniusweb.connection.ConnectionEnd;
 import geniusweb.references.Reference;
 import tudelft.utilities.listener.DefaultListenable;
@@ -17,5 +17,5 @@
  */
 public class BasicConnection<IN, OUT> extends DefaultListenable<IN>
-		implements Connection<IN, OUT> {
+		implements ConnectionEnd<IN, OUT> {
 	private final Reference reference;
 	private final URI uri;
Index: simplerunner/src/main/java/geniusweb/simplerunner/ClassPathConnectionFactory.java
===================================================================
--- simplerunner/src/main/java/geniusweb/simplerunner/ClassPathConnectionFactory.java	(revision 8)
+++ simplerunner/src/main/java/geniusweb/simplerunner/ClassPathConnectionFactory.java	(revision 9)
@@ -13,6 +13,6 @@
 import geniusweb.party.Party;
 import geniusweb.party.inform.Inform;
-import geniusweb.protocol.partyconnection.ConnectionWithParty;
-import geniusweb.protocol.partyconnection.ConnectionWithPartyFactory;
+import geniusweb.protocol.partyconnection.ProtocolToPartyConn;
+import geniusweb.protocol.partyconnection.ProtocolToPartyConnFactory;
 import geniusweb.references.Reference;
 import tudelft.utilities.repository.NoResourcesNowException;
@@ -25,5 +25,5 @@
  *
  */
-public class ClassPathConnectionFactory implements ConnectionWithPartyFactory {
+public class ClassPathConnectionFactory implements ProtocolToPartyConnFactory {
 	private static final String SCHEME = "classpath";
 	private static int serialcounter = 1;
@@ -31,5 +31,5 @@
 
 	@Override
-	public ConnectionWithParty connect(Reference reference) {
+	public ProtocolToPartyConn connect(Reference reference) {
 		// set up the whole other party including the connection to it.
 		String classpath = getClassPath(reference.getURI());
@@ -42,6 +42,6 @@
 				uri("classpath:" + reference.getURI().getSchemeSpecificPart()
 						+ "." + (serialcounter++)));
-		party2protocol.init(action -> protocol2party.notifyChange(action));
-		protocol2party.init(info -> party2protocol.notifyChange(info));
+		party2protocol.init(action -> protocol2party.notifyListeners(action));
+		protocol2party.init(info -> party2protocol.notifyListeners(info));
 
 		party.connect(party2protocol);
@@ -102,7 +102,7 @@
 
 	@Override
-	public List<ConnectionWithParty> connect(List<Reference> references)
+	public List<ProtocolToPartyConn> connect(List<Reference> references)
 			throws IOException, NoResourcesNowException {
-		List<ConnectionWithParty> connections = new LinkedList<>();
+		List<ProtocolToPartyConn> connections = new LinkedList<>();
 		for (Reference partyref : references) {
 			connections.add(connect(partyref));
@@ -114,5 +114,5 @@
 
 class BasicConnectionWithParty extends BasicConnection<Action, Inform>
-		implements ConnectionWithParty {
+		implements ProtocolToPartyConn {
 
 	private PartyId id;
Index: simplerunner/src/main/java/geniusweb/simplerunner/NegoRunner.java
===================================================================
--- simplerunner/src/main/java/geniusweb/simplerunner/NegoRunner.java	(revision 8)
+++ simplerunner/src/main/java/geniusweb/simplerunner/NegoRunner.java	(revision 9)
@@ -13,5 +13,5 @@
 import geniusweb.protocol.NegoProtocol;
 import geniusweb.protocol.NegoSettings;
-import geniusweb.protocol.partyconnection.ConnectionWithPartyFactory;
+import geniusweb.protocol.partyconnection.ProtocolToPartyConnFactory;
 import geniusweb.protocol.session.SessionSettings;
 import tudelft.utilities.logging.ReportToLogger;
@@ -27,10 +27,10 @@
 	private final NegoSettings settings;
 	private final NegoProtocol protocol;
-	private final ConnectionWithPartyFactory connectionfactory;
+	private final ProtocolToPartyConnFactory connectionfactory;
 	private final Reporter log;
 	private final static ObjectMapper jackson = new ObjectMapper();
 
 	public NegoRunner(NegoSettings settings,
-			ConnectionWithPartyFactory connectionfactory, Reporter logger) {
+			ProtocolToPartyConnFactory connectionfactory, Reporter logger) {
 		if (settings == null || connectionfactory == null) {
 			throw new NullPointerException("Arguments must be not null");
Index: simplerunner/src/test/java/geniusweb/simplerunner/ClassPathConnectionFactoryTest.java
===================================================================
--- simplerunner/src/test/java/geniusweb/simplerunner/ClassPathConnectionFactoryTest.java	(revision 8)
+++ simplerunner/src/test/java/geniusweb/simplerunner/ClassPathConnectionFactoryTest.java	(revision 9)
@@ -10,5 +10,5 @@
 
 import geniusweb.actions.Action;
-import geniusweb.connection.Connection;
+import geniusweb.connection.ConnectionEnd;
 import geniusweb.party.inform.Inform;
 import geniusweb.references.PartyRef;
@@ -42,5 +42,5 @@
 	@Test
 	public void testRandomParty() throws IOException, URISyntaxException {
-		Connection<Action, Inform> party = factory.connect(new PartyRef(
+		ConnectionEnd<Action, Inform> party = factory.connect(new PartyRef(
 				"classpath:geniusweb.exampleparties.randomparty.RandomParty"));
 		assertNotNull(party);
Index: simplerunner/src/test/java/geniusweb/simplerunner/SessionRunnerTest.java
===================================================================
--- simplerunner/src/test/java/geniusweb/simplerunner/SessionRunnerTest.java	(revision 8)
+++ simplerunner/src/test/java/geniusweb/simplerunner/SessionRunnerTest.java	(revision 9)
@@ -18,5 +18,5 @@
 import geniusweb.protocol.CurrentNegoState;
 import geniusweb.protocol.ProtocolException;
-import geniusweb.protocol.partyconnection.ConnectionWithPartyFactory;
+import geniusweb.protocol.partyconnection.ProtocolToPartyConnFactory;
 import geniusweb.protocol.session.SessionProtocol;
 import geniusweb.protocol.session.SessionSettings;
@@ -47,5 +47,5 @@
 	public void smokeTest() {
 		new NegoRunner(mock(SessionSettings.class),
-				mock(ConnectionWithPartyFactory.class), logger);
+				mock(ProtocolToPartyConnFactory.class), logger);
 	}
 
@@ -56,6 +56,6 @@
 		when(settings.getProtocol(logger)).thenReturn(protocol);
 		@SuppressWarnings("unchecked")
-		ConnectionWithPartyFactory factory = mock(
-				ConnectionWithPartyFactory.class);
+		ProtocolToPartyConnFactory factory = mock(
+				ProtocolToPartyConnFactory.class);
 
 		NegoRunner runner = spy(
@@ -80,6 +80,6 @@
 		Reporter logger = mock(Reporter.class);
 		@SuppressWarnings("unchecked")
-		ConnectionWithPartyFactory factory = mock(
-				ConnectionWithPartyFactory.class);
+		ProtocolToPartyConnFactory factory = mock(
+				ProtocolToPartyConnFactory.class);
 		NegoRunner runner = spy(
 				new NegoRunner(settings, factory, logger));
@@ -107,6 +107,6 @@
 		when(protocol.getState()).thenReturn(state);
 		@SuppressWarnings("unchecked")
-		ConnectionWithPartyFactory factory = mock(
-				ConnectionWithPartyFactory.class);
+		ProtocolToPartyConnFactory factory = mock(
+				ProtocolToPartyConnFactory.class);
 		NegoRunner runner = spy(
 				new NegoRunner(settings, factory, logger));
